package chocobar.combi;

import graph.Vertice;

/** 
 * Classe pour encapsuler le Vertices.
 */
final class ChocoBarSet implements VerticeSet
{
	ChocoBar[] cbList;
	int size;
	
	/**
	 * Constructeur
	 */
	ChocoBarSet(ChocoBar[] cl)
	{
		cbList = cl;
		size = cl.length;
	}
	
	public ChocoBar item(int idx)
	{
		return cbList[idx];
	}

	// Implmentation de VerticeSet
	public Vertice elementAt(int idx)
	{
		return cbList[idx];
	}

	/** Recherche de l'id d'un vertice. 
	 * Renvoie -1 si on ne le trouve pas
	 */
	public int getIdOf(Vertice v)
	{
		// On parcoure tout le tableau
		for (int i=0; (i<size); i++) {
			if (v.equals(cbList[i])) {
				return i;
			}
		}
		// On ne l'a pas trouv, on retourne -1
		return -1;
	}
	
	public boolean contains(Vertice v) 
	{
		return (getIdOf(v) != -1);
	}
	
	public int size()
	{
		return this.size;
	}
}
