package chocobar.combi;

import java.util.Collection; // listes
import java.util.Vector;

import exception.*;

public interface EdgeModel {
  	public int getCardV();
	public void addEdge(int srcV,int dstV) throws OutOfRangeVerticeException;
	public boolean isEdge(int srcV,int dstV);
	public int setSize(int size);
	public int withOnlyEdges(int srcV, Vector dstV);
	public Collection getAdjacent(int srcV);
	public Collection getIncident(int dstV);
	public int getSourceVertice(); //racine du graphe
	public int getFinalVertice(); //sommet final (un seul) du graphe
	public void clear(); //no edges
	public void fill(); //edges to everywhere

	public void addVertice(); // add vertice at the end
	public void removeVerticeAt(int index) throws OutOfRangeVerticeException;
}
