package conf;

/**
 * Classe pour la configuration
 */

public final class ChocoConfig
{
	/*
	 * Cannot Instantiate it
	 */
	private ChocoConfig() {}
	
	/**
	 * Dfinit la taille de la ChocoBar.
	 * On utilise 8 x 6 pour les benchmark
	 */
	public static int size;
	public static int height;

	/**
	 * Dfinit le style de ChocoBar  utiliser.
	 * Par exemple :
	 * - cbl ( avec une liste de BreakPoints )
	 * - combi (  base de combinaisons )
	 */
	public static String chocoBarStyle = "combi";

	/**
	 * Dfinit la classe de ChocoBar  utiliser.
	 * Par exemple :
	 * - cbl.ChocoBar
	 * - combi.ChocoBarLong
	 * - combi.ChocoBarBigInt
	 * - combi.ChocoBarArray
	 */
	public static String chocoBarModel = "combi.ChocoBarLong";

	/**
	 * Dfinit la classe de EdgeModel  utiliser.
	 * - EdgeBigIntModel
	 * - EdgeBitSetModel
	 * - EdgeListModel
	 * - EdgeMatrixModel
	 */
	public static String edgeModel = "EdgeBigIntModel";
}	
