package graph;

import java.text.ParseException;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.util.Collection;
import java.util.Vector;

import exception.*;

public interface GenericGraph
{
	public int getInitialState();
	public int getFinalState();
	public int getCardV();
	public int setSize(int size);
	public Collection getAdjacent(int i) throws OutOfRangeVerticeException;	
	public Collection getIncident(int i) throws OutOfRangeVerticeException;	
	public String toDot();
	public String toTxt();
	public int withOnlyEdges(int sommetInt, Vector gagnant);
	public void loadFromFile(String filename)
		throws ParseException, IOException, FileNotFoundException;
}
