package jeu;

import java.util.*;

import graph.GenericGraph;

public class Simulation{
  /**
   * Fonction qui simule une partie joue par A (le premier a faire un coup
   * et B sur un jeu donne par un graphe g. Le jeu part de l'etat start pour 
   * arriver a l'etat finish
   **/
  public static void simulate(Strategy A, Strategy B, GenericGraph g){
	  int courant, interm;
	  int start=g.getInitialState();
	  int finish=g.getFinalState();
	
	  courant=start;
	  while(courant != finish){
		  interm=A.getNextConfig(courant);
		  System.out.println("Premier jouer deplace de vertice "+courant+" vers "+interm);
		  if (interm == finish){
			  System.out.println("Deuxieme joueur gagne");
			  return;
		  }
		  courant=B.getNextConfig(interm);
		  System.out.println("Deuxieme jouer deplace de vertice "+interm+" vers "+courant);
	  }
	  System.out.println("Premier joueur gagne");
  }
}
